/**********************************************************************

*	Project     : Unix/Linux Socket2air Example Applications

*	Description : notify2 <Ip Addr> <Login> <Pw> <MessageID>

*  compiler for Unix  : gcc -o query2 -lsocket query2.c

*  compiler for Linux : gcc -o query2 query2.c

**********************************************************************/

#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <time.h>

#include <sys/socket.h>

#include <netinet/in.h>



#define SERV_PORT 8000  //Server Port



struct Send_Msg{

   unsigned	char  msg_type;		//TA

   unsigned	char  msg_coding;	//TsX

   unsigned	char  msg_priority;	//Tuv

   unsigned	char  msg_country_code; //X

   unsigned	char  msg_set_len;	//msg_set[] Te

   unsigned	char  msg_content_len;	//msg_content[]Te

             	char  msg_set[100];	//TƳ]w

              	char  msg_content[160];	//²Te

};



struct Ret_Msg{

   unsigned	char  ret_code ;	//^ǰTNX

   unsigned	char  ret_coding ; 	//TsX

   unsigned	char  ret_set_len;	//ret_set[] Te

   unsigned	char  ret_content_len;	//ret_content[]Te

           	char  ret_set[80];	//T

           	char  ret_content[160];	//MessageID or Ț^Ǫ²Te

};



int FillMsg(char *src, char *target, int n)

{

   int i,len;

   len = strlen(target);

   for(i=0; i<len; i++)

	src[n++] = target[i];

   src[n++] = '\0';

   return(n);

}



void LogMessage(char *info, char *Login, char *MsgId, char *Msg)

{

   char str_time[50];

   char TmpStr[300];

   time_t tnow;

   struct tm *lctime;

   FILE *fp;

   if( (fp=fopen("query2.log","a+")) == NULL )

      return;

   time(&tnow);

   lctime = localtime(&tnow);

   strftime(str_time, 80, "%Y%m%d.%H%M%S", lctime);

   sprintf(TmpStr,"%s %8s %s %s %s\n", str_time, Login, MsgId, info, Msg);

   fputs(TmpStr, fp);

   fclose(fp);

}



int main(int argc, char *argv[])

{

int i,iPos,ret;

int sockfd;

struct Send_Msg sendMsg;

struct Ret_Msg retMsg;

struct sockaddr_in servaddr;



char IpAddr[20] = "";		//Server IP 

char Login[10] = "";		//nJb

char Pw[10] = "";		//nJKX

char TelNum[20] = "";		//T̪X

char Send_Type[3];              //]wǰeΦ 01: Yɶǰe 03:ɶǰe 

char Msg_Set[100] = "";	//d߮xsMessageID



if(argc<5)

{

   printf("\nUsage : query2 <Ip Addr> <Login> <Pw> <MsgID> ");

   printf("\n <ex>: query2 202.39.54.130 test test1 A8485839053681622407");

   printf("\nOutput: query2.log");

   printf("\n <ex>: <Date.Time> <Login> <MessageId> <Status> <Msg>\n");

   LogMessage("Fail:Argument_Error! ","", "", "");

   exit(0);

}



strcpy(IpAddr, argv[1]);

strcpy(Login, argv[2]);

strcpy(Pw, argv[3]);

strcpy(Msg_Set, argv[4]);



/******* Startup Socket *******/

if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)

   printf("socket error");

bzero(&servaddr, sizeof(servaddr));

servaddr.sin_family = AF_INET;

servaddr.sin_port   = htons(SERV_PORT);

if (inet_pton(AF_INET, argv[1], &servaddr.sin_addr) <= 0){

   printf("socket inet_pton error for %s", argv[1]);

   exit(0);

}

if (connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0){

   printf("socket connect error");

   exit(0);

}



/******* ˬdUsername,Pwb/KX *******/

memset((char *)&sendMsg, 0, sizeof(sendMsg));

sendMsg.msg_type = 0;

iPos = 0; 

iPos = FillMsg(&sendMsg.msg_set[0], Login, iPos); //NbJmsg_set

iPos = FillMsg(&sendMsg.msg_set[0], Pw, iPos);   //NKXJmsg_set

sendMsg.msg_set_len = iPos;



if((ret = write(sockfd , (char *)&sendMsg, sizeof(sendMsg)))<0){

   printf("socket sending User/Pwd error");

   close(sockfd);

   LogMessage("Fail:Socket Sending_User/Pwd_Error! ",Login, "", "");

   exit(0);

}

   

memset((char *)&retMsg, 0, sizeof(retMsg));	

if((ret = read(sockfd , (char *)&retMsg, sizeof(retMsg)))<0){   

   printf("socket receiving User/Pwd error");

   close(sockfd);

   LogMessage("Fail:Socket Receiving_User/Pwd_Error! ",Login, "","");

   exit(0);

}

if(retMsg.ret_code != 0 ){

   printf("Login/Password_Error !\n");

   close(sockfd);

   LogMessage("Fail:Login/Password_Error! ",Login, "", "");

   exit(0);

}

printf("%s", retMsg.ret_content);



/******* d߶ǰeG *******/

memset((char *)&sendMsg, 0, sizeof(sendMsg));

sendMsg.msg_type = 2;   //TA 2 -> d߶ǰeG

sendMsg.msg_coding = 1; //TsX : 1 -> big5 sX

strcpy(Send_Type,"01");  //]wǰeΦ 01: Yɶǰe



iPos = 0;

iPos = FillMsg(&sendMsg.msg_set[0], Msg_Set, iPos);//NMessageIDJmsg_set

sendMsg.msg_set_len = iPos;



if((ret = write(sockfd , (char *)&sendMsg, sizeof(sendMsg)))<0){

   printf("socket sending message error");

   close(sockfd);

   LogMessage("Fail:Socket Sending_Message_Error! ",Login, "","");

   exit(0);

}



memset((char *)&retMsg, 0, sizeof(retMsg));

if((ret = read(sockfd , (char *)&retMsg, sizeof(retMsg)))<0){   

   printf("socket receiving message error");

   close(sockfd);

   LogMessage("Fail:Socket Receiving_User/Pwd_Error! ",Login, "","");

   exit(0);

}



printf("\nret_code[%d],ret_content[%s]\n", retMsg.ret_code,retMsg.ret_content);

LogMessage("Success! ",Login, Msg_Set, retMsg.ret_content);

close(sockfd);

}

